package jp.sourceforge.functional.getter;

public class InvalidHolder<T> implements ValidateGetter<T> {
	private static final InvalidHolder<?> _instance = new InvalidHolder<Object>();

	private InvalidHolder() {}

	@Override
	public T get() {
		throw new IllegalStateException();
	}

	@Override
	public boolean validity() {
		return false;
	}

	@SuppressWarnings("unchecked")
	public static <T> InvalidHolder<T> getInstance() {
		return (InvalidHolder<T>) _instance;
	}
}
